/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER     "0.1"
#define BUFFSZ  24

#ifndef u_char
    typedef unsigned char   u_char;
#endif



void the_universal_pwd(unsigned char *pwd);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE    *fd;
    u_char  buff[BUFFSZ + 1];


    setbuf(stdout, NULL);

    fputs("\n"
        "The Universal (Galaxy) password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <Tractor.cfx>\n"
            "\n", argv[0]);
        fputs("\n   Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("- open file \"%s\"\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    fseek(fd, 4, SEEK_SET);

    fread(buff, BUFFSZ, 1, fd);
    printf("\n  Character:   %s\n", buff);

    fread(buff, BUFFSZ, 1, fd);
    the_universal_pwd(buff);
    printf("  Password:    %s\n", buff);

    if(fseek(fd, 244, SEEK_SET) < 0) std_err();
    fread(buff, BUFFSZ, 1, fd);
    printf("  Username:    %s\n", buff);

    fclose(fd);
    fputs("\n   Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void the_universal_pwd(unsigned char *pwd) {
    const  static u_char    encdata[] =
                    "\x4E\x25\x15\x28\x32\x1F\x0B\x11\x0A\x12\x0C\x2D\x60\x58\x36\x2B"
                    "\x3E\x56\x77\x49\x21\x18\x2F\x40";
    int                     i;

    for(i = 0; i < BUFFSZ; i++) {
        if(!*pwd) break;
        *pwd++ -= encdata[i];
    }
    *pwd = 0;
}



void std_err(void) {
    perror("\nError");
    fputs("\n   Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


